
//
// To jest przykadowy kod z podrozdziau 26.3.3.2 Zarzdzanie zasobami ksiki
// "Programowanie. Teoria i praktyka z wykorzystaniem C++" Bjarne'a Stroustrupa.
//

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <stdio.h>

using namespace std;

//------------------------------------------------------------------------------

struct Bad_arg {};

//------------------------------------------------------------------------------

void do_resources1(int a, int b, const string& s) // marna funkcja
      // niezdyscyplinowane wykorzystanie zasobw
{
    FILE* f = fopen(s.c_str(),"r");    // Otwiera plik (styl jzyka C).
    int* p = new int[a];               // Alokuje troch pamici.
    if (b<=0) throw Bad_arg();         // Moe zgosi wyjtek.
    int* q = new int[b];       // Alokuje troch wicej pamici.
    delete[] p;                // Dealokuje pami wskazywan przez p.
}

//------------------------------------------------------------------------------

void do_resources2(int a, int b, const string& s) // troch lepsza funkcja
{
    ifstream is(s.c_str(),ios_base::in); // Otwiera plik.
    vector<int>v1(a);          // Tworzy wektor (posiadajcy pami).
    if (b<=0) throw Bad_arg(); // Moe zgosi wyjtek.
    vector<int> v2(b);         // Tworzy inny wektor (posiadajcy pami).
}

//------------------------------------------------------------------------------

int* var = 0;

//------------------------------------------------------------------------------

FILE* do_resources3(int a, int* p, const string& s) // marna funkcja
      // niezdyscyplinowane przekazywanie zasobw
{
    FILE* f = fopen(s.c_str(),"r");
    delete p;
    delete var;
    var = new int[27];
    return f;
}

//------------------------------------------------------------------------------

int main()
try
{
}
catch (exception& e) {
    cerr << "Bd: " << e.what() << '\n'; 
    return 1;
}
catch (...) {
    cerr << "Nieznany wyjtek!\n"; 
    return 2;
}

//------------------------------------------------------------------------------
